

import java.util.*;
import JavaGroups.*;


public class DispatcherTest implements MembershipListener {

    public class DateFunclet {
	public Date GetDate() {return new Date();}
    }


    Dispatcher     disp;
    final String   groupname="DispatcherTest";


    public void Start() {
	try {
	    disp=new Dispatcher(new JChannelFactory(), null);
	    disp.AddFunclet(groupname, this, "DateFunclet", new DateFunclet());
	    disp.SetMembershipListener(groupname, this);
	    disp.Join(groupname, this);

	    // for(int i=0; i < 10; i++) {
	    // 		Object retval=disp.SendGetFirst(groupname, 
	    // 						new MethodCall("GetDate", "DateFunclet"), 0);
	    // 		System.out.println(retval);
	    // 	    }

	    Thread.currentThread().sleep(50000);


	    disp.Leave(groupname, this);
	    disp.Destroy();
	}
	catch(Exception e) {
	    System.err.println(e);
	}	
    }


    public void ViewAccepted(View v) {
	System.out.println("NEW VIEW: " + v);
    }

    public void Suspect(Object suspected_mbr) {}

    public void Block() {}
    

    public static void main(String args[]) {
	DispatcherTest t=new DispatcherTest();
	t.Start();
    }
}
